package example.controller;

import example.model.Result;
import example.model.User;
import example.service.IUserService;
import example.service.impl.UserServiceImpl;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

@WebServlet("/login")
public class LoginServlet extends HttpServlet {

    IUserService userService = new UserServiceImpl();

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        resp.setContentType("application/json;charset=utf-8");
        req.setCharacterEncoding("utf-8");

        String username = req.getParameter("username");
        String password = req.getParameter("password");
        String captcha = req.getParameter("captcha");

        try {
            if (!captcha.equalsIgnoreCase((String) req.getSession().getAttribute("captcha"))) {
                resp.getWriter().write(toJson(Result.error("验证码错误")));
                return;
            }

            User user = userService.login(username, password);
            if (user != null) {
                req.getSession().setAttribute("user", user);
                resp.getWriter().write(toJson(Result.success("登录成功")));
            } else {
                resp.getWriter().write(toJson(Result.error("用户名或密码错误")));
            }
        } catch (Exception e) {
            e.printStackTrace();
            resp.getWriter().write(toJson(Result.error("系统错误，请稍后重试")));
        }
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        resp.sendRedirect("/login.jsp");
    }

    private String toJson(Object object) {
        // 使用简单的 JSON 序列化方式，实际可以使用 Jackson 或 Gson 库
        return new com.google.gson.Gson().toJson(object);
    }
}

