package example.model;

public class Result<T> {
    private String status; // "success" 或 "error"
    private String message; // 消息内容
    private T data; // 附加数据

    public Result(String status, String message, T data) {
        this.status = status;
        this.message = message;
        this.data = data;
    }

    public Result(String status, String message) {
        this(status, message, null);
    }

    public String getStatus() {
        return status;
    }

    public String getMessage() {
        return message;
    }

    public T getData() {
        return data;
    }

    public static <T> Result<T> success(String message, T data) {
        return new Result<>("success", message, data);
    }

    public static <T> Result<T> success(String message) {
        return success(message, null);
    }

    public static <T> Result<T> error(String message) {
        return new Result<>("error", message, null);
    }
}
